unit WinCryptImports;

interface

procedure ImportTest;

implementation

uses
  WinCrypt, NTStatus, BCrypt, NCrypt, SysUtils;

procedure ImportTest;
begin
  Writeln;
  Writeln('Import test');
  Writeln('===========');

  // WinCrypt import test

  Writeln;
  Writeln('advapi32');
  Writeln;

  Writeln(Format('%p -- %s', [@CryptAcquireContextA, 'CryptAcquireContextA']));
  Writeln(Format('%p -- %s', [@CryptAcquireContextW, 'CryptAcquireContextW']));
  Writeln(Format('%p -- %s', [@CryptAcquireContext, 'CryptAcquireContext']));
  Writeln(Format('%p -- %s', [@CryptGenKey, 'CryptGenKey']));
  Writeln(Format('%p -- %s', [@CryptDeriveKey, 'CryptDeriveKey']));
  Writeln(Format('%p -- %s', [@CryptDestroyKey, 'CryptDestroyKey']));
  Writeln(Format('%p -- %s', [@CryptSetKeyParam, 'CryptSetKeyParam']));
  Writeln(Format('%p -- %s', [@CryptGetKeyParam, 'CryptGetKeyParam']));
  Writeln(Format('%p -- %s', [@CryptSetHashParam, 'CryptSetHashParam']));
  Writeln(Format('%p -- %s', [@CryptGetHashParam, 'CryptGetHashParam']));
  Writeln(Format('%p -- %s', [@CryptSetProvParam, 'CryptSetProvParam']));
  Writeln(Format('%p -- %s', [@CryptGetProvParam, 'CryptGetProvParam']));
  Writeln(Format('%p -- %s', [@CryptGenRandom, 'CryptGenRandom']));
  Writeln(Format('%p -- %s', [@CryptGetUserKey, 'CryptGetUserKey']));
  Writeln(Format('%p -- %s', [@CryptExportKey, 'CryptExportKey']));
  Writeln(Format('%p -- %s', [@CryptImportKey, 'CryptImportKey']));
  Writeln(Format('%p -- %s', [@CryptEncrypt, 'CryptEncrypt']));
  Writeln(Format('%p -- %s', [@CryptDecrypt, 'CryptDecrypt']));
  Writeln(Format('%p -- %s', [@CryptCreateHash, 'CryptCreateHash']));
  Writeln(Format('%p -- %s', [@CryptHashData, 'CryptHashData']));
  Writeln(Format('%p -- %s', [@CryptHashSessionKey, 'CryptHashSessionKey']));
  Writeln(Format('%p -- %s', [@CryptDestroyHash, 'CryptDestroyHash']));
  Writeln(Format('%p -- %s', [@CryptSignHashA, 'CryptSignHashA']));
  Writeln(Format('%p -- %s', [@CryptSignHashW, 'CryptSignHashW']));
  Writeln(Format('%p -- %s', [@CryptSignHash, 'CryptSignHash']));
  Writeln(Format('%p -- %s', [@CryptVerifySignatureA, 'CryptVerifySignatureA']));
  Writeln(Format('%p -- %s', [@CryptVerifySignatureW, 'CryptVerifySignatureW']));
  Writeln(Format('%p -- %s', [@CryptVerifySignature, 'CryptVerifySignature']));
  Writeln(Format('%p -- %s', [@CryptSetProviderA, 'CryptSetProviderA']));
  Writeln(Format('%p -- %s', [@CryptSetProviderW, 'CryptSetProviderW']));
  Writeln(Format('%p -- %s', [@CryptSetProvider, 'CryptSetProvider']));
  Writeln(Format('%p -- %s', [@CryptSetProviderExA, 'CryptSetProviderExA']));
  Writeln(Format('%p -- %s', [@CryptSetProviderExW, 'CryptSetProviderExW']));
  Writeln(Format('%p -- %s', [@CryptSetProviderEx, 'CryptSetProviderEx']));
  Writeln(Format('%p -- %s', [@CryptGetDefaultProviderA, 'CryptGetDefaultProviderA']));
  Writeln(Format('%p -- %s', [@CryptGetDefaultProviderW, 'CryptGetDefaultProviderW']));
  Writeln(Format('%p -- %s', [@CryptGetDefaultProvider, 'CryptGetDefaultProvider']));
  Writeln(Format('%p -- %s', [@CryptEnumProviderTypesA, 'CryptEnumProviderTypesA']));
  Writeln(Format('%p -- %s', [@CryptEnumProviderTypesW, 'CryptEnumProviderTypesW']));
  Writeln(Format('%p -- %s', [@CryptEnumProviderTypes, 'CryptEnumProviderTypes']));
  Writeln(Format('%p -- %s', [@CryptEnumProvidersA, 'CryptEnumProvidersA']));
  Writeln(Format('%p -- %s', [@CryptEnumProvidersW, 'CryptEnumProvidersW']));
  Writeln(Format('%p -- %s', [@CryptEnumProviders, 'CryptEnumProviders']));
  Writeln(Format('%p -- %s', [@CryptContextAddRef, 'CryptContextAddRef']));
  Writeln(Format('%p -- %s', [@CryptDuplicateKey, 'CryptDuplicateKey']));
  Writeln(Format('%p -- %s', [@CryptDuplicateHash, 'CryptDuplicateHash']));

  Writeln;
  Writeln('crypt32');
  Writeln;

  Writeln(Format('%p -- %s', [@CryptFormatObject, 'CryptFormatObject']));
  Writeln(Format('%p -- %s', [@CryptEncodeObjectEx, 'CryptEncodeObjectEx']));
  Writeln(Format('%p -- %s', [@CryptEncodeObject, 'CryptEncodeObject']));
  Writeln(Format('%p -- %s', [@CryptDecodeObjectEx, 'CryptDecodeObjectEx']));
  Writeln(Format('%p -- %s', [@CryptDecodeObject, 'CryptDecodeObject']));
  Writeln(Format('%p -- %s', [@CryptInstallOIDFunctionAddress, 'CryptInstallOIDFunctionAddress']));
  Writeln(Format('%p -- %s', [@CryptInitOIDFunctionSet, 'CryptInitOIDFunctionSet']));
  Writeln(Format('%p -- %s', [@CryptGetOIDFunctionAddress, 'CryptGetOIDFunctionAddress']));
  Writeln(Format('%p -- %s', [@CryptGetDefaultOIDDllList, 'CryptGetDefaultOIDDllList']));
  Writeln(Format('%p -- %s', [@CryptGetDefaultOIDFunctionAddress, 'CryptGetDefaultOIDFunctionAddress']));
  Writeln(Format('%p -- %s', [@CryptFreeOIDFunctionAddress, 'CryptFreeOIDFunctionAddress']));
  Writeln(Format('%p -- %s', [@CryptRegisterOIDFunction, 'CryptRegisterOIDFunction']));
  Writeln(Format('%p -- %s', [@CryptUnregisterOIDFunction, 'CryptUnregisterOIDFunction']));
  Writeln(Format('%p -- %s', [@CryptRegisterDefaultOIDFunction, 'CryptRegisterDefaultOIDFunction']));
  Writeln(Format('%p -- %s', [@CryptUnregisterDefaultOIDFunction, 'CryptUnregisterDefaultOIDFunction']));
  Writeln(Format('%p -- %s', [@CryptSetOIDFunctionValue, 'CryptSetOIDFunctionValue']));
  Writeln(Format('%p -- %s', [@CryptGetOIDFunctionValue, 'CryptGetOIDFunctionValue']));
  Writeln(Format('%p -- %s', [@CryptEnumOIDFunction, 'CryptEnumOIDFunction']));
  Writeln(Format('%p -- %s', [@CryptFindOIDInfo, 'CryptFindOIDInfo']));
  Writeln(Format('%p -- %s', [@CryptRegisterOIDInfo, 'CryptRegisterOIDInfo']));
  Writeln(Format('%p -- %s', [@CryptUnregisterOIDInfo, 'CryptUnregisterOIDInfo']));
  Writeln(Format('%p -- %s', [@CryptEnumOIDInfo, 'CryptEnumOIDInfo']));
  Writeln(Format('%p -- %s', [@CryptFindLocalizedName, 'CryptFindLocalizedName']));
  Writeln(Format('%p -- %s', [@CryptMsgOpenToEncode, 'CryptMsgOpenToEncode']));
  Writeln(Format('%p -- %s', [@CryptMsgCalculateEncodedLength, 'CryptMsgCalculateEncodedLength']));
  Writeln(Format('%p -- %s', [@CryptMsgOpenToDecode, 'CryptMsgOpenToDecode']));
  Writeln(Format('%p -- %s', [@CryptMsgDuplicate, 'CryptMsgDuplicate']));
  Writeln(Format('%p -- %s', [@CryptMsgClose, 'CryptMsgClose']));
  Writeln(Format('%p -- %s', [@CryptMsgUpdate, 'CryptMsgUpdate']));
  Writeln(Format('%p -- %s', [@CryptMsgGetParam, 'CryptMsgGetParam']));
  Writeln(Format('%p -- %s', [@CryptMsgControl, 'CryptMsgControl']));
  Writeln(Format('%p -- %s', [@CryptMsgVerifyCountersignatureEncoded, 'CryptMsgVerifyCountersignatureEncoded']));
  Writeln(Format('%p -- %s', [@CryptMsgVerifyCountersignatureEncodedEx, 'CryptMsgVerifyCountersignatureEncodedEx']));
  Writeln(Format('%p -- %s', [@CryptMsgCountersign, 'CryptMsgCountersign']));
  Writeln(Format('%p -- %s', [@CryptMsgCountersignEncoded, 'CryptMsgCountersignEncoded']));
  Writeln(Format('%p -- %s', [@CertOpenStore, 'CertOpenStore']));
  Writeln(Format('%p -- %s', [@CertDuplicateStore, 'CertDuplicateStore']));
  Writeln(Format('%p -- %s', [@CertSaveStore, 'CertSaveStore']));
  Writeln(Format('%p -- %s', [@CertCloseStore, 'CertCloseStore']));
  Writeln(Format('%p -- %s', [@CertGetSubjectCertificateFromStore, 'CertGetSubjectCertificateFromStore']));
  Writeln(Format('%p -- %s', [@CertEnumCertificatesInStore, 'CertEnumCertificatesInStore']));
  Writeln(Format('%p -- %s', [@CertFindCertificateInStore, 'CertFindCertificateInStore']));
  Writeln(Format('%p -- %s', [@CertGetIssuerCertificateFromStore, 'CertGetIssuerCertificateFromStore']));
  Writeln(Format('%p -- %s', [@CertVerifySubjectCertificateContext, 'CertVerifySubjectCertificateContext']));
  Writeln(Format('%p -- %s', [@CertDuplicateCertificateContext, 'CertDuplicateCertificateContext']));
  Writeln(Format('%p -- %s', [@CertCreateCertificateContext, 'CertCreateCertificateContext']));
  Writeln(Format('%p -- %s', [@CertFreeCertificateContext, 'CertFreeCertificateContext']));
  Writeln(Format('%p -- %s', [@CertSetCertificateContextProperty, 'CertSetCertificateContextProperty']));
  Writeln(Format('%p -- %s', [@CertGetCertificateContextProperty, 'CertGetCertificateContextProperty']));
  Writeln(Format('%p -- %s', [@CertEnumCertificateContextProperties, 'CertEnumCertificateContextProperties']));
  Writeln(Format('%p -- %s', [@CertCreateCTLEntryFromCertificateContextProperties, 'CertCreateCTLEntryFromCertificateContextProperties']));
  Writeln(Format('%p -- %s', [@CertSetCertificateContextPropertiesFromCTLEntry, 'CertSetCertificateContextPropertiesFromCTLEntry']));
  Writeln(Format('%p -- %s', [@CertGetCRLFromStore, 'CertGetCRLFromStore']));
  Writeln(Format('%p -- %s', [@CertEnumCRLsInStore, 'CertEnumCRLsInStore']));
  Writeln(Format('%p -- %s', [@CertFindCRLInStore, 'CertFindCRLInStore']));
  Writeln(Format('%p -- %s', [@CertDuplicateCRLContext, 'CertDuplicateCRLContext']));
  Writeln(Format('%p -- %s', [@CertCreateCRLContext, 'CertCreateCRLContext']));
  Writeln(Format('%p -- %s', [@CertFreeCRLContext, 'CertFreeCRLContext']));
  Writeln(Format('%p -- %s', [@CertSetCRLContextProperty, 'CertSetCRLContextProperty']));
  Writeln(Format('%p -- %s', [@CertGetCRLContextProperty, 'CertGetCRLContextProperty']));
  Writeln(Format('%p -- %s', [@CertEnumCRLContextProperties, 'CertEnumCRLContextProperties']));
  Writeln(Format('%p -- %s', [@CertFindCertificateInCRL, 'CertFindCertificateInCRL']));
  Writeln(Format('%p -- %s', [@CertIsValidCRLForCertificate, 'CertIsValidCRLForCertificate']));
  Writeln(Format('%p -- %s', [@CertAddEncodedCertificateToStore, 'CertAddEncodedCertificateToStore']));
  Writeln(Format('%p -- %s', [@CertAddCertificateContextToStore, 'CertAddCertificateContextToStore']));
  Writeln(Format('%p -- %s', [@CertAddSerializedElementToStore, 'CertAddSerializedElementToStore']));
  Writeln(Format('%p -- %s', [@CertDeleteCertificateFromStore, 'CertDeleteCertificateFromStore']));
  Writeln(Format('%p -- %s', [@CertAddEncodedCRLToStore, 'CertAddEncodedCRLToStore']));
  Writeln(Format('%p -- %s', [@CertAddCRLContextToStore, 'CertAddCRLContextToStore']));
  Writeln(Format('%p -- %s', [@CertDeleteCRLFromStore, 'CertDeleteCRLFromStore']));
  Writeln(Format('%p -- %s', [@CertSerializeCertificateStoreElement, 'CertSerializeCertificateStoreElement']));
  Writeln(Format('%p -- %s', [@CertSerializeCRLStoreElement, 'CertSerializeCRLStoreElement']));
  Writeln(Format('%p -- %s', [@CertDuplicateCTLContext, 'CertDuplicateCTLContext']));
  Writeln(Format('%p -- %s', [@CertCreateCTLContext, 'CertCreateCTLContext']));
  Writeln(Format('%p -- %s', [@CertFreeCTLContext, 'CertFreeCTLContext']));
  Writeln(Format('%p -- %s', [@CertSetCTLContextProperty, 'CertSetCTLContextProperty']));
  Writeln(Format('%p -- %s', [@CertGetCTLContextProperty, 'CertGetCTLContextProperty']));
  Writeln(Format('%p -- %s', [@CertEnumCTLContextProperties, 'CertEnumCTLContextProperties']));
  Writeln(Format('%p -- %s', [@CertEnumCTLsInStore, 'CertEnumCTLsInStore']));
  Writeln(Format('%p -- %s', [@CertFindSubjectInCTL, 'CertFindSubjectInCTL']));
  Writeln(Format('%p -- %s', [@CertFindCTLInStore, 'CertFindCTLInStore']));
  Writeln(Format('%p -- %s', [@CertAddEncodedCTLToStore, 'CertAddEncodedCTLToStore']));
  Writeln(Format('%p -- %s', [@CertAddCTLContextToStore, 'CertAddCTLContextToStore']));
  Writeln(Format('%p -- %s', [@CertSerializeCTLStoreElement, 'CertSerializeCTLStoreElement']));
  Writeln(Format('%p -- %s', [@CertDeleteCTLFromStore, 'CertDeleteCTLFromStore']));
  Writeln(Format('%p -- %s', [@CertAddCertificateLinkToStore, 'CertAddCertificateLinkToStore']));
  Writeln(Format('%p -- %s', [@CertAddCRLLinkToStore, 'CertAddCRLLinkToStore']));
  Writeln(Format('%p -- %s', [@CertAddCTLLinkToStore, 'CertAddCTLLinkToStore']));
  Writeln(Format('%p -- %s', [@CertAddStoreToCollection, 'CertAddStoreToCollection']));
  Writeln(Format('%p -- %s', [@CertRemoveStoreFromCollection, 'CertRemoveStoreFromCollection']));
  Writeln(Format('%p -- %s', [@CertControlStore, 'CertControlStore']));
  Writeln(Format('%p -- %s', [@CertSetStoreProperty, 'CertSetStoreProperty']));
  Writeln(Format('%p -- %s', [@CertGetStoreProperty, 'CertGetStoreProperty']));
  Writeln(Format('%p -- %s', [@CertCreateContext, 'CertCreateContext']));
  Writeln(Format('%p -- %s', [@CertRegisterSystemStore, 'CertRegisterSystemStore']));
  Writeln(Format('%p -- %s', [@CertRegisterPhysicalStore, 'CertRegisterPhysicalStore']));
  Writeln(Format('%p -- %s', [@CertUnregisterSystemStore, 'CertUnregisterSystemStore']));
  Writeln(Format('%p -- %s', [@CertUnregisterPhysicalStore, 'CertUnregisterPhysicalStore']));
  Writeln(Format('%p -- %s', [@CertEnumSystemStoreLocation, 'CertEnumSystemStoreLocation']));
  Writeln(Format('%p -- %s', [@CertEnumSystemStore, 'CertEnumSystemStore']));
  Writeln(Format('%p -- %s', [@CertEnumPhysicalStore, 'CertEnumPhysicalStore']));
  Writeln(Format('%p -- %s', [@CertGetEnhancedKeyUsage, 'CertGetEnhancedKeyUsage']));
  Writeln(Format('%p -- %s', [@CertSetEnhancedKeyUsage, 'CertSetEnhancedKeyUsage']));
  Writeln(Format('%p -- %s', [@CertAddEnhancedKeyUsageIdentifier, 'CertAddEnhancedKeyUsageIdentifier']));
  Writeln(Format('%p -- %s', [@CertRemoveEnhancedKeyUsageIdentifier, 'CertRemoveEnhancedKeyUsageIdentifier']));
  Writeln(Format('%p -- %s', [@CertGetValidUsages, 'CertGetValidUsages']));
  Writeln(Format('%p -- %s', [@CryptMsgGetAndVerifySigner, 'CryptMsgGetAndVerifySigner']));
  Writeln(Format('%p -- %s', [@CryptMsgSignCTL, 'CryptMsgSignCTL']));
  Writeln(Format('%p -- %s', [@CryptMsgEncodeAndSignCTL, 'CryptMsgEncodeAndSignCTL']));
  Writeln(Format('%p -- %s', [@CertFindSubjectInSortedCTL, 'CertFindSubjectInSortedCTL']));
  Writeln(Format('%p -- %s', [@CertEnumSubjectInSortedCTL, 'CertEnumSubjectInSortedCTL']));
  Writeln(Format('%p -- %s', [@CertVerifyCTLUsage, 'CertVerifyCTLUsage']));
  Writeln(Format('%p -- %s', [@CertVerifyRevocation, 'CertVerifyRevocation']));
  Writeln(Format('%p -- %s', [@CertCompareIntegerBlob, 'CertCompareIntegerBlob']));
  Writeln(Format('%p -- %s', [@CertCompareCertificate, 'CertCompareCertificate']));
  Writeln(Format('%p -- %s', [@CertCompareCertificateName, 'CertCompareCertificateName']));
  Writeln(Format('%p -- %s', [@CertIsRDNAttrsInCertificateName, 'CertIsRDNAttrsInCertificateName']));
  Writeln(Format('%p -- %s', [@CertComparePublicKeyInfo, 'CertComparePublicKeyInfo']));
  Writeln(Format('%p -- %s', [@CertGetPublicKeyLength, 'CertGetPublicKeyLength']));
  Writeln(Format('%p -- %s', [@CryptVerifyCertificateSignature, 'CryptVerifyCertificateSignature']));
  Writeln(Format('%p -- %s', [@CryptVerifyCertificateSignatureEx, 'CryptVerifyCertificateSignatureEx']));
  Writeln(Format('%p -- %s', [@CryptHashToBeSigned, 'CryptHashToBeSigned']));
  Writeln(Format('%p -- %s', [@CryptHashCertificate, 'CryptHashCertificate']));
  Writeln(Format('%p -- %s', [@CryptHashCertificate2, 'CryptHashCertificate2']));
  Writeln(Format('%p -- %s', [@CryptSignCertificate, 'CryptSignCertificate']));
  Writeln(Format('%p -- %s', [@CryptSignAndEncodeCertificate, 'CryptSignAndEncodeCertificate']));
  Writeln(Format('%p -- %s', [@CertVerifyTimeValidity, 'CertVerifyTimeValidity']));
  Writeln(Format('%p -- %s', [@CertVerifyCRLTimeValidity, 'CertVerifyCRLTimeValidity']));
  Writeln(Format('%p -- %s', [@CertVerifyValidityNesting, 'CertVerifyValidityNesting']));
  Writeln(Format('%p -- %s', [@CertVerifyCRLRevocation, 'CertVerifyCRLRevocation']));
  Writeln(Format('%p -- %s', [@CertAlgIdToOID, 'CertAlgIdToOID']));
  Writeln(Format('%p -- %s', [@CertOIDToAlgId, 'CertOIDToAlgId']));
  Writeln(Format('%p -- %s', [@CertFindExtension, 'CertFindExtension']));
  Writeln(Format('%p -- %s', [@CertFindAttribute, 'CertFindAttribute']));
  Writeln(Format('%p -- %s', [@CertFindRDNAttr, 'CertFindRDNAttr']));
  Writeln(Format('%p -- %s', [@CertGetIntendedKeyUsage, 'CertGetIntendedKeyUsage']));
  Writeln(Format('%p -- %s', [@CryptInstallDefaultContext, 'CryptInstallDefaultContext']));
  Writeln(Format('%p -- %s', [@CryptUninstallDefaultContext, 'CryptUninstallDefaultContext']));
  Writeln(Format('%p -- %s', [@CryptExportPublicKeyInfo, 'CryptExportPublicKeyInfo']));
  Writeln(Format('%p -- %s', [@CryptExportPublicKeyInfoEx, 'CryptExportPublicKeyInfoEx']));
  Writeln(Format('%p -- %s', [@CryptImportPublicKeyInfo, 'CryptImportPublicKeyInfo']));
  Writeln(Format('%p -- %s', [@CryptImportPublicKeyInfoEx, 'CryptImportPublicKeyInfoEx']));
  Writeln(Format('%p -- %s', [@CryptImportPublicKeyInfoEx2, 'CryptImportPublicKeyInfoEx2']));
  Writeln(Format('%p -- %s', [@CryptAcquireCertificatePrivateKey, 'CryptAcquireCertificatePrivateKey']));
  Writeln(Format('%p -- %s', [@CryptFindCertificateKeyProvInfo, 'CryptFindCertificateKeyProvInfo']));
  Writeln(Format('%p -- %s', [@CryptImportPKCS8, 'CryptImportPKCS8']));
  Writeln(Format('%p -- %s', [@CryptExportPKCS8, 'CryptExportPKCS8']));
  Writeln(Format('%p -- %s', [@CryptExportPKCS8Ex, 'CryptExportPKCS8Ex']));
  Writeln(Format('%p -- %s', [@CryptHashPublicKeyInfo, 'CryptHashPublicKeyInfo']));
  Writeln(Format('%p -- %s', [@CertRDNValueToStrA, 'CertRDNValueToStrA']));
  Writeln(Format('%p -- %s', [@CertRDNValueToStrW, 'CertRDNValueToStrW']));
  Writeln(Format('%p -- %s', [@CertRDNValueToStr, 'CertRDNValueToStr']));
  Writeln(Format('%p -- %s', [@CertNameToStrA, 'CertNameToStrA']));
  Writeln(Format('%p -- %s', [@CertNameToStrW, 'CertNameToStrW']));
  Writeln(Format('%p -- %s', [@CertNameToStr, 'CertNameToStr']));
  Writeln(Format('%p -- %s', [@CertStrToNameA, 'CertStrToNameA']));
  Writeln(Format('%p -- %s', [@CertStrToNameW, 'CertStrToNameW']));
  Writeln(Format('%p -- %s', [@CertStrToName, 'CertStrToName']));
  Writeln(Format('%p -- %s', [@CertGetNameStringA, 'CertGetNameStringA']));
  Writeln(Format('%p -- %s', [@CertGetNameStringW, 'CertGetNameStringW']));
  Writeln(Format('%p -- %s', [@CertGetNameString, 'CertGetNameString']));
  Writeln(Format('%p -- %s', [@CryptSignMessage, 'CryptSignMessage']));
  Writeln(Format('%p -- %s', [@CryptVerifyMessageSignature, 'CryptVerifyMessageSignature']));
  Writeln(Format('%p -- %s', [@CryptGetMessageSignerCount, 'CryptGetMessageSignerCount']));
  Writeln(Format('%p -- %s', [@CryptGetMessageCertificates, 'CryptGetMessageCertificates']));
  Writeln(Format('%p -- %s', [@CryptVerifyDetachedMessageSignature, 'CryptVerifyDetachedMessageSignature']));
  Writeln(Format('%p -- %s', [@CryptEncryptMessage, 'CryptEncryptMessage']));
  Writeln(Format('%p -- %s', [@CryptDecryptMessage, 'CryptDecryptMessage']));
  Writeln(Format('%p -- %s', [@CryptSignAndEncryptMessage, 'CryptSignAndEncryptMessage']));
  Writeln(Format('%p -- %s', [@CryptDecryptAndVerifyMessageSignature, 'CryptDecryptAndVerifyMessageSignature']));
  Writeln(Format('%p -- %s', [@CryptDecodeMessage, 'CryptDecodeMessage']));
  Writeln(Format('%p -- %s', [@CryptHashMessage, 'CryptHashMessage']));
  Writeln(Format('%p -- %s', [@CryptVerifyMessageHash, 'CryptVerifyMessageHash']));
  Writeln(Format('%p -- %s', [@CryptVerifyDetachedMessageHash, 'CryptVerifyDetachedMessageHash']));
  Writeln(Format('%p -- %s', [@CryptSignMessageWithKey, 'CryptSignMessageWithKey']));
  Writeln(Format('%p -- %s', [@CryptVerifyMessageSignatureWithKey, 'CryptVerifyMessageSignatureWithKey']));
  Writeln(Format('%p -- %s', [@CertOpenSystemStoreA, 'CertOpenSystemStoreA']));
  Writeln(Format('%p -- %s', [@CertOpenSystemStoreW, 'CertOpenSystemStoreW']));
  Writeln(Format('%p -- %s', [@CertOpenSystemStore, 'CertOpenSystemStore']));
  Writeln(Format('%p -- %s', [@CertAddEncodedCertificateToSystemStoreA, 'CertAddEncodedCertificateToSystemStoreA']));
  Writeln(Format('%p -- %s', [@CertAddEncodedCertificateToSystemStoreW, 'CertAddEncodedCertificateToSystemStoreW']));
  Writeln(Format('%p -- %s', [@CertAddEncodedCertificateToSystemStore, 'CertAddEncodedCertificateToSystemStore']));

  Writeln(Format('%p -- %s', [@CryptQueryObject, 'CryptQueryObject']));
  Writeln(Format('%p -- %s', [@CryptMemAlloc, 'CryptMemAlloc']));
  Writeln(Format('%p -- %s', [@CryptMemRealloc, 'CryptMemRealloc']));
  Writeln(Format('%p -- %s', [@CryptMemFree, 'CryptMemFree']));
  Writeln(Format('%p -- %s', [@CryptCreateAsyncHandle, 'CryptCreateAsyncHandle']));
  Writeln(Format('%p -- %s', [@CryptSetAsyncParam, 'CryptSetAsyncParam']));
  Writeln(Format('%p -- %s', [@CryptGetAsyncParam, 'CryptGetAsyncParam']));
  Writeln(Format('%p -- %s', [@CryptCloseAsyncHandle, 'CryptCloseAsyncHandle']));
  Writeln(Format('%p -- %s', [@CryptProtectData, 'CryptProtectData']));
  Writeln(Format('%p -- %s', [@CryptUnprotectData, 'CryptUnprotectData']));
  Writeln(Format('%p -- %s', [@CryptUpdateProtectedState, 'CryptUpdateProtectedState']));
  Writeln(Format('%p -- %s', [@CryptProtectMemory, 'CryptProtectMemory']));
  Writeln(Format('%p -- %s', [@CryptUnprotectMemory, 'CryptUnprotectMemory']));
  Writeln(Format('%p -- %s', [@CertCreateSelfSignCertificate, 'CertCreateSelfSignCertificate']));
  Writeln(Format('%p -- %s', [@CryptGetKeyIdentifierProperty, 'CryptGetKeyIdentifierProperty']));
  Writeln(Format('%p -- %s', [@CryptSetKeyIdentifierProperty, 'CryptSetKeyIdentifierProperty']));
  Writeln(Format('%p -- %s', [@CryptEnumKeyIdentifierProperties, 'CryptEnumKeyIdentifierProperties']));
  Writeln(Format('%p -- %s', [@CryptCreateKeyIdentifierFromCSP, 'CryptCreateKeyIdentifierFromCSP']));
  Writeln(Format('%p -- %s', [@CertCreateCertificateChainEngine, 'CertCreateCertificateChainEngine']));
  Writeln(Format('%p -- %s', [@CertFreeCertificateChainEngine, 'CertFreeCertificateChainEngine']));
  Writeln(Format('%p -- %s', [@CertResyncCertificateChainEngine, 'CertResyncCertificateChainEngine']));
  Writeln(Format('%p -- %s', [@CertGetCertificateChain, 'CertGetCertificateChain']));
  Writeln(Format('%p -- %s', [@CertFreeCertificateChain, 'CertFreeCertificateChain']));
  Writeln(Format('%p -- %s', [@CertDuplicateCertificateChain, 'CertDuplicateCertificateChain']));
  Writeln(Format('%p -- %s', [@CertFindChainInStore, 'CertFindChainInStore']));
  Writeln(Format('%p -- %s', [@CertVerifyCertificateChainPolicy, 'CertVerifyCertificateChainPolicy']));
  Writeln(Format('%p -- %s', [@CryptStringToBinaryA, 'CryptStringToBinaryA']));
  Writeln(Format('%p -- %s', [@CryptStringToBinaryW, 'CryptStringToBinaryW']));
  Writeln(Format('%p -- %s', [@CryptStringToBinary, 'CryptStringToBinary']));
  Writeln(Format('%p -- %s', [@CryptBinaryToStringA, 'CryptBinaryToStringA']));
  Writeln(Format('%p -- %s', [@CryptBinaryToStringW, 'CryptBinaryToStringW']));
  Writeln(Format('%p -- %s', [@CryptBinaryToString, 'CryptBinaryToString']));
  Writeln(Format('%p -- %s', [@PFXImportCertStore, 'PFXImportCertStore']));
  Writeln(Format('%p -- %s', [@PFXIsPFXBlob, 'PFXIsPFXBlob']));
  Writeln(Format('%p -- %s', [@PFXVerifyPassword, 'PFXVerifyPassword']));
  Writeln(Format('%p -- %s', [@PFXExportCertStoreEx, 'PFXExportCertStoreEx']));
  Writeln(Format('%p -- %s', [@PFXExportCertStore, 'PFXExportCertStore']));
  Writeln(Format('%p -- %s', [@CertOpenServerOcspResponse, 'CertOpenServerOcspResponse']));
  Writeln(Format('%p -- %s', [@CertAddRefServerOcspResponse, 'CertAddRefServerOcspResponse']));
  Writeln(Format('%p -- %s', [@CertCloseServerOcspResponse, 'CertCloseServerOcspResponse']));
  Writeln(Format('%p -- %s', [@CertGetServerOcspResponseContext, 'CertGetServerOcspResponseContext']));
  Writeln(Format('%p -- %s', [@CertAddRefServerOcspResponseContext, 'CertAddRefServerOcspResponseContext']));
  Writeln(Format('%p -- %s', [@CertFreeServerOcspResponseContext, 'CertFreeServerOcspResponseContext']));
  Writeln(Format('%p -- %s', [@CertRetrieveLogoOrBiometricInfo, 'CertRetrieveLogoOrBiometricInfo']));

  Writeln;
  Writeln('softpub');
  Writeln;

  Writeln(Format('%p -- %s', [@FindCertsByIssuer, 'FindCertsByIssuer']));

  Writeln;
  Writeln('cryptnet');
  Writeln;

  Writeln(Format('%p -- %s', [@CryptRetrieveObjectByUrlA, 'CryptRetrieveObjectByUrlA']));
  Writeln(Format('%p -- %s', [@CryptRetrieveObjectByUrlW, 'CryptRetrieveObjectByUrlW']));
  Writeln(Format('%p -- %s', [@CryptRetrieveObjectByUrl, 'CryptRetrieveObjectByUrl']));
  Writeln(Format('%p -- %s', [@CryptInstallCancelRetrieval, 'CryptInstallCancelRetrieval']));
  Writeln(Format('%p -- %s', [@CryptUninstallCancelRetrieval, 'CryptUninstallCancelRetrieval']));
  Writeln(Format('%p -- %s', [@CryptCancelAsyncRetrieval, 'CryptCancelAsyncRetrieval']));
  Writeln(Format('%p -- %s', [@CryptGetObjectUrl, 'CryptGetObjectUrl']));
  Writeln(Format('%p -- %s', [@CryptGetTimeValidObject, 'CryptGetTimeValidObject']));
  Writeln(Format('%p -- %s', [@CryptFlushTimeValidObject, 'CryptFlushTimeValidObject']));

  Writeln;
  Writeln('bcrypt');
  Writeln;

  Writeln(Format('%p -- %s', [@BCryptOpenAlgorithmProvider, 'BCryptOpenAlgorithmProvider']));
  Writeln(Format('%p -- %s', [@BCryptEnumAlgorithms, 'BCryptEnumAlgorithms']));
  Writeln(Format('%p -- %s', [@BCryptEnumProviders, 'BCryptEnumProviders']));
  Writeln(Format('%p -- %s', [@BCryptGetProperty, 'BCryptGetProperty']));
  Writeln(Format('%p -- %s', [@BCryptSetProperty, 'BCryptSetProperty']));
  Writeln(Format('%p -- %s', [@BCryptCloseAlgorithmProvider, 'BCryptCloseAlgorithmProvider']));
  Writeln(Format('%p -- %s', [@BCryptFreeBuffer, 'BCryptFreeBuffer']));
  Writeln(Format('%p -- %s', [@BCryptGenerateSymmetricKey, 'BCryptGenerateSymmetricKey']));
  Writeln(Format('%p -- %s', [@BCryptGenerateKeyPair, 'BCryptGenerateKeyPair']));
  Writeln(Format('%p -- %s', [@BCryptEncrypt, 'BCryptEncrypt']));
  Writeln(Format('%p -- %s', [@BCryptDecrypt, 'BCryptDecrypt']));
  Writeln(Format('%p -- %s', [@BCryptExportKey, 'BCryptExportKey']));
  Writeln(Format('%p -- %s', [@BCryptImportKey, 'BCryptImportKey']));
  Writeln(Format('%p -- %s', [@BCryptImportKeyPair, 'BCryptImportKeyPair']));
  Writeln(Format('%p -- %s', [@BCryptDuplicateKey, 'BCryptDuplicateKey']));
  Writeln(Format('%p -- %s', [@BCryptFinalizeKeyPair, 'BCryptFinalizeKeyPair']));
  Writeln(Format('%p -- %s', [@BCryptDestroyKey, 'BCryptDestroyKey']));
  Writeln(Format('%p -- %s', [@BCryptDestroySecret, 'BCryptDestroySecret']));
  Writeln(Format('%p -- %s', [@BCryptSignHash, 'BCryptSignHash']));
  Writeln(Format('%p -- %s', [@BCryptVerifySignature, 'BCryptVerifySignature']));
  Writeln(Format('%p -- %s', [@BCryptSecretAgreement, 'BCryptSecretAgreement']));
  Writeln(Format('%p -- %s', [@BCryptDeriveKey, 'BCryptDeriveKey']));
  Writeln(Format('%p -- %s', [@BCryptCreateHash, 'BCryptCreateHash']));
  Writeln(Format('%p -- %s', [@BCryptHashData, 'BCryptHashData']));
  Writeln(Format('%p -- %s', [@BCryptFinishHash, 'BCryptFinishHash']));
  Writeln(Format('%p -- %s', [@BCryptDuplicateHash, 'BCryptDuplicateHash']));
  Writeln(Format('%p -- %s', [@BCryptDestroyHash, 'BCryptDestroyHash']));
  Writeln(Format('%p -- %s', [@BCryptGenRandom, 'BCryptGenRandom']));

  Writeln(Format('%p -- %s', [@BCryptQueryProviderRegistration, 'BCryptQueryProviderRegistration']));
  Writeln(Format('%p -- %s', [@BCryptEnumRegisteredProviders, 'BCryptEnumRegisteredProviders']));
  Writeln(Format('%p -- %s', [@BCryptCreateContext, 'BCryptCreateContext']));
  Writeln(Format('%p -- %s', [@BCryptDeleteContext, 'BCryptDeleteContext']));
  Writeln(Format('%p -- %s', [@BCryptEnumContexts, 'BCryptEnumContexts']));
  Writeln(Format('%p -- %s', [@BCryptConfigureContext, 'BCryptConfigureContext']));
  Writeln(Format('%p -- %s', [@BCryptQueryContextConfiguration, 'BCryptQueryContextConfiguration']));
  Writeln(Format('%p -- %s', [@BCryptAddContextFunction, 'BCryptAddContextFunction']));
  Writeln(Format('%p -- %s', [@BCryptRemoveContextFunction, 'BCryptRemoveContextFunction']));
  Writeln(Format('%p -- %s', [@BCryptEnumContextFunctions, 'BCryptEnumContextFunctions']));
  Writeln(Format('%p -- %s', [@BCryptConfigureContextFunction, 'BCryptConfigureContextFunction']));
  Writeln(Format('%p -- %s', [@BCryptQueryContextFunctionConfiguration, 'BCryptQueryContextFunctionConfiguration']));
  Writeln(Format('%p -- %s', [@BCryptEnumContextFunctionProviders, 'BCryptEnumContextFunctionProviders']));
  Writeln(Format('%p -- %s', [@BCryptSetContextFunctionProperty, 'BCryptSetContextFunctionProperty']));
  Writeln(Format('%p -- %s', [@BCryptQueryContextFunctionProperty, 'BCryptQueryContextFunctionProperty']));

  Writeln(Format('%p -- %s', [@BCryptRegisterConfigChangeNotify, 'BCryptRegisterConfigChangeNotify']));
  Writeln(Format('%p -- %s', [@BCryptUnregisterConfigChangeNotify, 'BCryptUnregisterConfigChangeNotify']));
  Writeln(Format('%p -- %s', [@BCryptResolveProviders, 'BCryptResolveProviders']));
  Writeln(Format('%p -- %s', [@BCryptGetFipsAlgorithmMode, 'BCryptGetFipsAlgorithmMode']));

  Writeln;
  Writeln('ncrypt');
  Writeln;

  Writeln(Format('%p -- %s', [@NCryptOpenStorageProvider, 'NCryptOpenStorageProvider']));
  Writeln(Format('%p -- %s', [@NCryptEnumAlgorithms, 'NCryptEnumAlgorithms']));
  Writeln(Format('%p -- %s', [@NCryptIsAlgSupported, 'NCryptIsAlgSupported']));
  Writeln(Format('%p -- %s', [@NCryptEnumKeys, 'NCryptEnumKeys']));
  Writeln(Format('%p -- %s', [@NCryptEnumStorageProviders, 'NCryptEnumStorageProviders']));
  Writeln(Format('%p -- %s', [@NCryptFreeBuffer, 'NCryptFreeBuffer']));
  Writeln(Format('%p -- %s', [@NCryptOpenKey, 'NCryptOpenKey']));
  Writeln(Format('%p -- %s', [@NCryptCreatePersistedKey, 'NCryptCreatePersistedKey']));
  Writeln(Format('%p -- %s', [@NCryptGetProperty, 'NCryptGetProperty']));
  Writeln(Format('%p -- %s', [@NCryptSetProperty, 'NCryptSetProperty']));
  Writeln(Format('%p -- %s', [@NCryptFinalizeKey, 'NCryptFinalizeKey']));
  Writeln(Format('%p -- %s', [@NCryptEncrypt, 'NCryptEncrypt']));
  Writeln(Format('%p -- %s', [@NCryptDecrypt, 'NCryptDecrypt']));
  Writeln(Format('%p -- %s', [@NCryptImportKey, 'NCryptImportKey']));
  Writeln(Format('%p -- %s', [@NCryptExportKey, 'NCryptExportKey']));
  Writeln(Format('%p -- %s', [@NCryptSignHash, 'NCryptSignHash']));
  Writeln(Format('%p -- %s', [@NCryptVerifySignature, 'NCryptVerifySignature']));
  Writeln(Format('%p -- %s', [@NCryptDeleteKey, 'NCryptDeleteKey']));
  Writeln(Format('%p -- %s', [@NCryptFreeObject, 'NCryptFreeObject']));
  Writeln(Format('%p -- %s', [@NCryptIsKeyHandle, 'NCryptIsKeyHandle']));
  Writeln(Format('%p -- %s', [@NCryptTranslateHandle, 'NCryptTranslateHandle']));
  Writeln(Format('%p -- %s', [@NCryptNotifyChangeKey, 'NCryptNotifyChangeKey']));
  Writeln(Format('%p -- %s', [@NCryptSecretAgreement, 'NCryptSecretAgreement']));
  Writeln(Format('%p -- %s', [@NCryptDeriveKey, 'NCryptDeriveKey']));

end;

end.

