unit WinCryptRecordSizes;

interface

procedure WriteRecordSizes;

implementation

uses
  SysUtils, WinCrypt, NCrypt, BCrypt, NTStatus;

procedure WriteRecordSizes;
begin
  Writeln;
  Writeln('Struct sizes');
  Writeln('============');
  Writeln;

  Writeln('wincrypt');
  Writeln('--------');
  Writeln;
  
  Writeln(Format('%-50s %8d', ['_VTableProvStruc', SizeOf(_VTableProvStruc)]));
  Writeln(Format('%-50s %8d', ['_CMS_KEY_INFO', SizeOf(_CMS_KEY_INFO)]));
  Writeln(Format('%-50s %8d', ['_HMAC_Info', SizeOf(_HMAC_Info)]));
  Writeln(Format('%-50s %8d', ['_SCHANNEL_ALG', SizeOf(_SCHANNEL_ALG )]));
  Writeln(Format('%-50s %8d', ['_PROV_ENUMALGS', SizeOf(_PROV_ENUMALGS)]));
  Writeln(Format('%-50s %8d', ['_PROV_ENUMALGS_EX', SizeOf(_PROV_ENUMALGS_EX)]));
  Writeln(Format('%-50s %8d', ['_PUBLICKEYSTRUC', SizeOf(_PUBLICKEYSTRUC)]));
  Writeln(Format('%-50s %8d', ['_RSAPUBKEY', SizeOf(_RSAPUBKEY)]));
  Writeln(Format('%-50s %8d', ['_PUBKEY', SizeOf(_PUBKEY)]));
  Writeln(Format('%-50s %8d', ['_DSSSEED', SizeOf(_DSSSEED)]));
  Writeln(Format('%-50s %8d', ['_PUBKEYVER3', SizeOf(_PUBKEYVER3)]));
  Writeln(Format('%-50s %8d', ['_PRIVKEYVER3', SizeOf(_PRIVKEYVER3)]));
  Writeln(Format('%-50s %8d', ['_KEY_TYPE_SUBTYPE', SizeOf(_KEY_TYPE_SUBTYPE)]));
  Writeln(Format('%-50s %8d', ['_CERT_FORTEZZA_DATA_PROP', SizeOf(_CERT_FORTEZZA_DATA_PROP)]));
  Writeln(Format('%-50s %8d', ['_CRYPT_RC4_KEY_STATE', SizeOf(_CRYPT_RC4_KEY_STATE)]));
  Writeln(Format('%-50s %8d', ['_CRYPT_DES_KEY_STATE', SizeOf(_CRYPT_DES_KEY_STATE)]));
  Writeln(Format('%-50s %8d', ['_CRYPT_3DES_KEY_STATE', SizeOf(_CRYPT_3DES_KEY_STATE)]));
  Writeln(Format('%-50s %8d', ['_CRYPT_AES_128_KEY_STATE', SizeOf(_CRYPT_AES_128_KEY_STATE)]));
  Writeln(Format('%-50s %8d', ['_CRYPT_AES_256_KEY_STATE', SizeOf(_CRYPT_AES_256_KEY_STATE)]));
  Writeln(Format('%-50s %8d', ['_CRYPTOAPI_BLOB', SizeOf(_CRYPTOAPI_BLOB)]));
  Writeln(Format('%-50s %8d', ['_CMS_DH_KEY_INFO', SizeOf(_CMS_DH_KEY_INFO)]));
  Writeln(Format('%-50s %8d', ['_CRYPT_KEY_LIMITS_V01', SizeOf(_CRYPT_KEY_LIMITS_V01)]));
  Writeln(Format('%-50s %8d', ['_CRYPT_BIT_BLOB', SizeOf(_CRYPT_BIT_BLOB)]));
  Writeln(Format('%-50s %8d', ['_CRYPT_ALGORITHM_IDENTIFIER', SizeOf(_CRYPT_ALGORITHM_IDENTIFIER)]));
  Writeln(Format('%-50s %8d', ['_CRYPT_OBJID_TABLE', SizeOf(_CRYPT_OBJID_TABLE)]));
  Writeln(Format('%-50s %8d', ['_CRYPT_HASH_INFO', SizeOf(_CRYPT_HASH_INFO)]));
  Writeln(Format('%-50s %8d', ['_CERT_EXTENSION', SizeOf(_CERT_EXTENSION)]));
  Writeln(Format('%-50s %8d', ['_CRYPT_ATTRIBUTE_TYPE_VALUE', SizeOf(_CRYPT_ATTRIBUTE_TYPE_VALUE)]));
  Writeln(Format('%-50s %8d', ['_CRYPT_ATTRIBUTE', SizeOf(_CRYPT_ATTRIBUTE)]));
  Writeln(Format('%-50s %8d', ['_CRYPT_ATTRIBUTES', SizeOf(_CRYPT_ATTRIBUTES)]));
  Writeln(Format('%-50s %8d', ['_CERT_RDN_ATTR', SizeOf(_CERT_RDN_ATTR)]));
  Writeln(Format('%-50s %8d', ['_CERT_RDN', SizeOf(_CERT_RDN)]));
  Writeln(Format('%-50s %8d', ['_CERT_NAME_INFO', SizeOf(_CERT_NAME_INFO)]));
  Writeln(Format('%-50s %8d', ['_CERT_NAME_VALUE', SizeOf(_CERT_NAME_VALUE)]));
  Writeln(Format('%-50s %8d', ['_CERT_PUBLIC_KEY_INFO', SizeOf(_CERT_PUBLIC_KEY_INFO)]));
  Writeln(Format('%-50s %8d', ['_CRYPT_PRIVATE_KEY_INFO', SizeOf(_CRYPT_PRIVATE_KEY_INFO)]));
  Writeln(Format('%-50s %8d', ['_CRYPT_ENCRYPTED_PRIVATE_KEY_INFO', SizeOf(_CRYPT_ENCRYPTED_PRIVATE_KEY_INFO)]));
  Writeln(Format('%-50s %8d', ['_CRYPT_PKCS8_IMPORT_PARAMS', SizeOf(_CRYPT_PKCS8_IMPORT_PARAMS)]));
  Writeln(Format('%-50s %8d', ['_CRYPT_PKCS8_EXPORT_PARAMS', SizeOf(_CRYPT_PKCS8_EXPORT_PARAMS)]));
  Writeln(Format('%-50s %8d', ['_CERT_INFO', SizeOf(_CERT_INFO)]));
  Writeln(Format('%-50s %8d', ['_CRL_ENTRY', SizeOf(_CRL_ENTRY)]));
  Writeln(Format('%-50s %8d', ['_CRL_INFO', SizeOf(_CRL_INFO)]));
  Writeln(Format('%-50s %8d', ['_CERT_REQUEST_INFO', SizeOf(_CERT_REQUEST_INFO)]));
  Writeln(Format('%-50s %8d', ['_CERT_KEYGEN_REQUEST_INFO', SizeOf(_CERT_KEYGEN_REQUEST_INFO)]));
  Writeln(Format('%-50s %8d', ['_CERT_SIGNED_CONTENT_INFO', SizeOf(_CERT_SIGNED_CONTENT_INFO)]));
  Writeln(Format('%-50s %8d', ['_CTL_USAGE', SizeOf(_CTL_USAGE)]));
  Writeln(Format('%-50s %8d', ['_CTL_ENTRY', SizeOf(_CTL_ENTRY)]));
  Writeln(Format('%-50s %8d', ['_CTL_INFO', SizeOf(_CTL_INFO)]));
  Writeln(Format('%-50s %8d', ['_CRYPT_TIME_STAMP_REQUEST_INFO', SizeOf(_CRYPT_TIME_STAMP_REQUEST_INFO)]));
  Writeln(Format('%-50s %8d', ['_CRYPT_ENROLLMENT_NAME_VALUE_PAIR', SizeOf(_CRYPT_ENROLLMENT_NAME_VALUE_PAIR)]));
  Writeln(Format('%-50s %8d', ['_CRYPT_CSP_PROVIDER', SizeOf(_CRYPT_CSP_PROVIDER)]));
  Writeln(Format('%-50s %8d', ['_CRYPT_ENCODE_PARA', SizeOf(_CRYPT_ENCODE_PARA)]));
  Writeln(Format('%-50s %8d', ['_CRYPT_DECODE_PARA', SizeOf(_CRYPT_DECODE_PARA)]));
  Writeln(Format('%-50s %8d', ['_CERT_EXTENSIONS', SizeOf(_CERT_EXTENSIONS)]));
  Writeln(Format('%-50s %8d', ['_CERT_AUTHORITY_KEY_ID_INFO', SizeOf(_CERT_AUTHORITY_KEY_ID_INFO)]));
  Writeln(Format('%-50s %8d', ['_CERT_PRIVATE_KEY_VALIDITY', SizeOf(_CERT_PRIVATE_KEY_VALIDITY)]));
  Writeln(Format('%-50s %8d', ['_CERT_KEY_ATTRIBUTES_INFO', SizeOf(_CERT_KEY_ATTRIBUTES_INFO)]));
  Writeln(Format('%-50s %8d', ['_CERT_POLICY_ID', SizeOf(_CERT_POLICY_ID)]));
  Writeln(Format('%-50s %8d', ['_CERT_KEY_USAGE_RESTRICTION_INFO', SizeOf(_CERT_KEY_USAGE_RESTRICTION_INFO)]));
  Writeln(Format('%-50s %8d', ['_CERT_OTHER_NAME', SizeOf(_CERT_OTHER_NAME)]));
  Writeln(Format('%-50s %8d', ['_CERT_ALT_NAME_ENTRY', SizeOf(_CERT_ALT_NAME_ENTRY)]));
  Writeln(Format('%-50s %8d', ['_CERT_ALT_NAME_INFO', SizeOf(_CERT_ALT_NAME_INFO)]));
  Writeln(Format('%-50s %8d', ['_CERT_BASIC_CONSTRAINTS_INFO', SizeOf(_CERT_BASIC_CONSTRAINTS_INFO)]));
  Writeln(Format('%-50s %8d', ['_CERT_BASIC_CONSTRAINTS2_INFO', SizeOf(_CERT_BASIC_CONSTRAINTS2_INFO)]));
  Writeln(Format('%-50s %8d', ['_CERT_POLICY_QUALIFIER_INFO', SizeOf(_CERT_POLICY_QUALIFIER_INFO)]));
  Writeln(Format('%-50s %8d', ['_CERT_POLICY_INFO', SizeOf(_CERT_POLICY_INFO)]));
  Writeln(Format('%-50s %8d', ['_CERT_POLICIES_INFO', SizeOf(_CERT_POLICIES_INFO)]));
  Writeln(Format('%-50s %8d', ['_CERT_POLICY_QUALIFIER_NOTICE_REFERENCE', SizeOf(_CERT_POLICY_QUALIFIER_NOTICE_REFERENCE)]));
  Writeln(Format('%-50s %8d', ['_CERT_POLICY_QUALIFIER_USER_NOTICE', SizeOf(_CERT_POLICY_QUALIFIER_USER_NOTICE)]));
  Writeln(Format('%-50s %8d', ['_CPS_URLS', SizeOf(_CPS_URLS)]));
  Writeln(Format('%-50s %8d', ['_CERT_POLICY95_QUALIFIER1', SizeOf(_CERT_POLICY95_QUALIFIER1)]));
  Writeln(Format('%-50s %8d', ['_CERT_POLICY_MAPPING', SizeOf(_CERT_POLICY_MAPPING)]));
  Writeln(Format('%-50s %8d', ['_CERT_POLICY_MAPPINGS_INFO', SizeOf(_CERT_POLICY_MAPPINGS_INFO)]));
  Writeln(Format('%-50s %8d', ['_CERT_POLICY_CONSTRAINTS_INFO', SizeOf(_CERT_POLICY_CONSTRAINTS_INFO)]));
  Writeln(Format('%-50s %8d', ['_CRYPT_CONTENT_INFO_SEQUENCE_OF_ANY', SizeOf(_CRYPT_CONTENT_INFO_SEQUENCE_OF_ANY)]));
  Writeln(Format('%-50s %8d', ['_CRYPT_CONTENT_INFO', SizeOf(_CRYPT_CONTENT_INFO)]));
  Writeln(Format('%-50s %8d', ['_CRYPT_SEQUENCE_OF_ANY', SizeOf(_CRYPT_SEQUENCE_OF_ANY)]));
  Writeln(Format('%-50s %8d', ['_CERT_AUTHORITY_KEY_ID2_INFO', SizeOf(_CERT_AUTHORITY_KEY_ID2_INFO)]));
  Writeln(Format('%-50s %8d', ['_CERT_ACCESS_DESCRIPTION', SizeOf(_CERT_ACCESS_DESCRIPTION)]));
  Writeln(Format('%-50s %8d', ['_CERT_AUTHORITY_INFO_ACCESS', SizeOf(_CERT_AUTHORITY_INFO_ACCESS)]));
  Writeln(Format('%-50s %8d', ['_CRL_DIST_POINT_NAME', SizeOf(_CRL_DIST_POINT_NAME)]));
  Writeln(Format('%-50s %8d', ['_CRL_DIST_POINT', SizeOf(_CRL_DIST_POINT)]));
  Writeln(Format('%-50s %8d', ['_CRL_DIST_POINTS_INFO', SizeOf(_CRL_DIST_POINTS_INFO)]));
  Writeln(Format('%-50s %8d', ['_CROSS_CERT_DIST_POINTS_INFO', SizeOf(_CROSS_CERT_DIST_POINTS_INFO)]));
  Writeln(Format('%-50s %8d', ['_CERT_PAIR', SizeOf(_CERT_PAIR)]));
  Writeln(Format('%-50s %8d', ['_CRL_ISSUING_DIST_POINT', SizeOf(_CRL_ISSUING_DIST_POINT)]));
  Writeln(Format('%-50s %8d', ['_CERT_GENERAL_SUBTREE', SizeOf(_CERT_GENERAL_SUBTREE)]));
  Writeln(Format('%-50s %8d', ['_CERT_NAME_CONSTRAINTS_INFO', SizeOf(_CERT_NAME_CONSTRAINTS_INFO)]));
  Writeln(Format('%-50s %8d', ['_CERT_DSS_PARAMETERS', SizeOf(_CERT_DSS_PARAMETERS)]));
  Writeln(Format('%-50s %8d', ['_CERT_DH_PARAMETERS', SizeOf(_CERT_DH_PARAMETERS)]));
  Writeln(Format('%-50s %8d', ['_CERT_ECC_SIGNATURE', SizeOf(_CERT_ECC_SIGNATURE)]));
  Writeln(Format('%-50s %8d', ['_CERT_X942_DH_VALIDATION_PARAMS', SizeOf(_CERT_X942_DH_VALIDATION_PARAMS)]));
  Writeln(Format('%-50s %8d', ['_CERT_X942_DH_PARAMETERS', SizeOf(_CERT_X942_DH_PARAMETERS)]));
  Writeln(Format('%-50s %8d', ['_CRYPT_X942_OTHER_INFO', SizeOf(_CRYPT_X942_OTHER_INFO)]));
  Writeln(Format('%-50s %8d', ['_CRYPT_ECC_CMS_SHARED_INFO', SizeOf(_CRYPT_ECC_CMS_SHARED_INFO)]));
  Writeln(Format('%-50s %8d', ['_CRYPT_RC2_CBC_PARAMETERS', SizeOf(_CRYPT_RC2_CBC_PARAMETERS)]));
  Writeln(Format('%-50s %8d', ['_CRYPT_SMIME_CAPABILITY', SizeOf(_CRYPT_SMIME_CAPABILITY)]));
  Writeln(Format('%-50s %8d', ['_CRYPT_SMIME_CAPABILITIES', SizeOf(_CRYPT_SMIME_CAPABILITIES)]));
  Writeln(Format('%-50s %8d', ['_CERT_QC_STATEMENT', SizeOf(_CERT_QC_STATEMENT)]));
  Writeln(Format('%-50s %8d', ['_CERT_QC_STATEMENTS_EXT_INFO', SizeOf(_CERT_QC_STATEMENTS_EXT_INFO)]));
  Writeln(Format('%-50s %8d', ['_CRYPT_MASK_GEN_ALGORITHM', SizeOf(_CRYPT_MASK_GEN_ALGORITHM)]));
  Writeln(Format('%-50s %8d', ['_CRYPT_RSA_SSA_PSS_PARAMETERS', SizeOf(_CRYPT_RSA_SSA_PSS_PARAMETERS)]));
  Writeln(Format('%-50s %8d', ['_CRYPT_PSOURCE_ALGORITHM', SizeOf(_CRYPT_PSOURCE_ALGORITHM)]));
  Writeln(Format('%-50s %8d', ['_CRYPT_RSAES_OAEP_PARAMETERS', SizeOf(_CRYPT_RSAES_OAEP_PARAMETERS)]));
  Writeln(Format('%-50s %8d', ['_CMC_TAGGED_ATTRIBUTE', SizeOf(_CMC_TAGGED_ATTRIBUTE)]));
  Writeln(Format('%-50s %8d', ['_CMC_TAGGED_CERT_REQUEST', SizeOf(_CMC_TAGGED_CERT_REQUEST)]));
  Writeln(Format('%-50s %8d', ['_CMC_TAGGED_REQUEST', SizeOf(_CMC_TAGGED_REQUEST)]));
  Writeln(Format('%-50s %8d', ['_CMC_TAGGED_CONTENT_INFO', SizeOf(_CMC_TAGGED_CONTENT_INFO)]));
  Writeln(Format('%-50s %8d', ['_CMC_TAGGED_OTHER_MSG', SizeOf(_CMC_TAGGED_OTHER_MSG)]));
  Writeln(Format('%-50s %8d', ['_CMC_DATA_INFO', SizeOf(_CMC_DATA_INFO)]));
  Writeln(Format('%-50s %8d', ['_CMC_RESPONSE_INFO', SizeOf(_CMC_RESPONSE_INFO)]));
  Writeln(Format('%-50s %8d', ['_CMC_PEND_INFO', SizeOf(_CMC_PEND_INFO)]));
  Writeln(Format('%-50s %8d', ['_CMC_STATUS_INFO', SizeOf(_CMC_STATUS_INFO)]));
  Writeln(Format('%-50s %8d', ['_CMC_ADD_EXTENSIONS_INFO', SizeOf(_CMC_ADD_EXTENSIONS_INFO)]));
  Writeln(Format('%-50s %8d', ['_CMC_ADD_ATTRIBUTES_INFO', SizeOf(_CMC_ADD_ATTRIBUTES_INFO)]));
  Writeln(Format('%-50s %8d', ['_CERT_TEMPLATE_EXT', SizeOf(_CERT_TEMPLATE_EXT)]));
  Writeln(Format('%-50s %8d', ['_CERT_HASHED_URL', SizeOf(_CERT_HASHED_URL)]));
  Writeln(Format('%-50s %8d', ['_CERT_LOGOTYPE_DETAILS', SizeOf(_CERT_LOGOTYPE_DETAILS)]));
  Writeln(Format('%-50s %8d', ['_CERT_LOGOTYPE_REFERENCE', SizeOf(_CERT_LOGOTYPE_REFERENCE)]));
  Writeln(Format('%-50s %8d', ['_CERT_LOGOTYPE_IMAGE_INFO', SizeOf(_CERT_LOGOTYPE_IMAGE_INFO)]));
  Writeln(Format('%-50s %8d', ['_CERT_LOGOTYPE_IMAGE', SizeOf(_CERT_LOGOTYPE_IMAGE)]));
  Writeln(Format('%-50s %8d', ['_CERT_LOGOTYPE_AUDIO_INFO', SizeOf(_CERT_LOGOTYPE_AUDIO_INFO)]));
  Writeln(Format('%-50s %8d', ['_CERT_LOGOTYPE_AUDIO', SizeOf(_CERT_LOGOTYPE_AUDIO)]));
  Writeln(Format('%-50s %8d', ['_CERT_LOGOTYPE_DATA', SizeOf(_CERT_LOGOTYPE_DATA)]));
  Writeln(Format('%-50s %8d', ['_CERT_LOGOTYPE_INFO', SizeOf(_CERT_LOGOTYPE_INFO)]));
  Writeln(Format('%-50s %8d', ['_CERT_OTHER_LOGOTYPE_INFO', SizeOf(_CERT_OTHER_LOGOTYPE_INFO)]));
  Writeln(Format('%-50s %8d', ['_CERT_LOGOTYPE_EXT_INFO', SizeOf(_CERT_LOGOTYPE_EXT_INFO)]));
  Writeln(Format('%-50s %8d', ['_CERT_BIOMETRIC_DATA', SizeOf(_CERT_BIOMETRIC_DATA)]));
  Writeln(Format('%-50s %8d', ['_CERT_BIOMETRIC_EXT_INFO', SizeOf(_CERT_BIOMETRIC_EXT_INFO)]));
  Writeln(Format('%-50s %8d', ['_OCSP_SIGNATURE_INFO', SizeOf(_OCSP_SIGNATURE_INFO)]));
  Writeln(Format('%-50s %8d', ['_OCSP_SIGNED_REQUEST_INFO', SizeOf(_OCSP_SIGNED_REQUEST_INFO)]));
  Writeln(Format('%-50s %8d', ['_OCSP_CERT_ID', SizeOf(_OCSP_CERT_ID)]));
  Writeln(Format('%-50s %8d', ['_OCSP_REQUEST_ENTRY', SizeOf(_OCSP_REQUEST_ENTRY)]));
  Writeln(Format('%-50s %8d', ['_OCSP_REQUEST_INFO', SizeOf(_OCSP_REQUEST_INFO)]));
  Writeln(Format('%-50s %8d', ['_OCSP_RESPONSE_INFO', SizeOf(_OCSP_RESPONSE_INFO)]));
  Writeln(Format('%-50s %8d', ['_OCSP_BASIC_SIGNED_RESPONSE_INFO', SizeOf(_OCSP_BASIC_SIGNED_RESPONSE_INFO)]));
  Writeln(Format('%-50s %8d', ['_OCSP_BASIC_REVOKED_INFO', SizeOf(_OCSP_BASIC_REVOKED_INFO)]));
  Writeln(Format('%-50s %8d', ['_OCSP_BASIC_RESPONSE_ENTRY', SizeOf(_OCSP_BASIC_RESPONSE_ENTRY)]));
  Writeln(Format('%-50s %8d', ['_OCSP_BASIC_RESPONSE_INFO', SizeOf(_OCSP_BASIC_RESPONSE_INFO)]));
  Writeln(Format('%-50s %8d', ['_CRYPT_OID_FUNC_ENTRY', SizeOf(_CRYPT_OID_FUNC_ENTRY)]));
  Writeln(Format('%-50s %8d', ['_CRYPT_OID_INFO', SizeOf(_CRYPT_OID_INFO)]));
  Writeln(Format('%-50s %8d', ['_CERT_ISSUER_SERIAL_NUMBER', SizeOf(_CERT_ISSUER_SERIAL_NUMBER)]));
  Writeln(Format('%-50s %8d', ['_CERT_ID', SizeOf(_CERT_ID)]));
  Writeln(Format('%-50s %8d', ['_CMSG_SIGNER_ENCODE_INFO', SizeOf(_CMSG_SIGNER_ENCODE_INFO)]));
  Writeln(Format('%-50s %8d', ['_CMSG_SIGNED_ENCODE_INFO', SizeOf(_CMSG_SIGNED_ENCODE_INFO)]));
  Writeln(Format('%-50s %8d', ['_CMSG_ENVELOPED_ENCODE_INFO', SizeOf(_CMSG_ENVELOPED_ENCODE_INFO)]));
  Writeln(Format('%-50s %8d', ['_CMSG_KEY_TRANS_RECIPIENT_ENCODE_INFO', SizeOf(_CMSG_KEY_TRANS_RECIPIENT_ENCODE_INFO)]));
  Writeln(Format('%-50s %8d', ['_CMSG_RECIPIENT_ENCRYPTED_KEY_ENCODE_INFO', SizeOf(_CMSG_RECIPIENT_ENCRYPTED_KEY_ENCODE_INFO)]));
  Writeln(Format('%-50s %8d', ['_CMSG_KEY_AGREE_RECIPIENT_ENCODE_INFO', SizeOf(_CMSG_KEY_AGREE_RECIPIENT_ENCODE_INFO)]));
  Writeln(Format('%-50s %8d', ['_CMSG_MAIL_LIST_RECIPIENT_ENCODE_INFO', SizeOf(_CMSG_MAIL_LIST_RECIPIENT_ENCODE_INFO)]));
  Writeln(Format('%-50s %8d', ['_CMSG_RECIPIENT_ENCODE_INFO', SizeOf(_CMSG_RECIPIENT_ENCODE_INFO)]));
  Writeln(Format('%-50s %8d', ['_CMSG_RC2_AUX_INFO', SizeOf(_CMSG_RC2_AUX_INFO)]));
  Writeln(Format('%-50s %8d', ['_CMSG_SP3_COMPATIBLE_AUX_INFO', SizeOf(_CMSG_SP3_COMPATIBLE_AUX_INFO)]));
  Writeln(Format('%-50s %8d', ['_CMSG_RC4_AUX_INFO', SizeOf(_CMSG_RC4_AUX_INFO)]));
  Writeln(Format('%-50s %8d', ['_CMSG_SIGNED_AND_ENVELOPED_ENCODE_INFO', SizeOf(_CMSG_SIGNED_AND_ENVELOPED_ENCODE_INFO)]));
  Writeln(Format('%-50s %8d', ['_CMSG_HASHED_ENCODE_INFO', SizeOf(_CMSG_HASHED_ENCODE_INFO)]));
  Writeln(Format('%-50s %8d', ['_CMSG_ENCRYPTED_ENCODE_INFO', SizeOf(_CMSG_ENCRYPTED_ENCODE_INFO)]));
  Writeln(Format('%-50s %8d', ['_CMSG_STREAM_INFO', SizeOf(_CMSG_STREAM_INFO)]));
  Writeln(Format('%-50s %8d', ['_CMSG_SIGNER_INFO', SizeOf(_CMSG_SIGNER_INFO)]));
  Writeln(Format('%-50s %8d', ['_CMSG_CMS_SIGNER_INFO', SizeOf(_CMSG_CMS_SIGNER_INFO)]));
  Writeln(Format('%-50s %8d', ['_CMSG_KEY_TRANS_RECIPIENT_INFO', SizeOf(_CMSG_KEY_TRANS_RECIPIENT_INFO)]));
  Writeln(Format('%-50s %8d', ['_CMSG_RECIPIENT_ENCRYPTED_KEY_INFO', SizeOf(_CMSG_RECIPIENT_ENCRYPTED_KEY_INFO)]));
  Writeln(Format('%-50s %8d', ['_CMSG_KEY_AGREE_RECIPIENT_INFO', SizeOf(_CMSG_KEY_AGREE_RECIPIENT_INFO)]));
  Writeln(Format('%-50s %8d', ['_CMSG_MAIL_LIST_RECIPIENT_INFO', SizeOf(_CMSG_MAIL_LIST_RECIPIENT_INFO)]));
  Writeln(Format('%-50s %8d', ['_CMSG_CMS_RECIPIENT_INFO', SizeOf(_CMSG_CMS_RECIPIENT_INFO)]));
  Writeln(Format('%-50s %8d', ['_CMSG_CTRL_VERIFY_SIGNATURE_EX_PARA', SizeOf(_CMSG_CTRL_VERIFY_SIGNATURE_EX_PARA)]));
  Writeln(Format('%-50s %8d', ['_CMSG_CTRL_DECRYPT_PARA', SizeOf(_CMSG_CTRL_DECRYPT_PARA)]));
  Writeln(Format('%-50s %8d', ['_CMSG_CTRL_KEY_TRANS_DECRYPT_PARA', SizeOf(_CMSG_CTRL_KEY_TRANS_DECRYPT_PARA)]));
  Writeln(Format('%-50s %8d', ['_CMSG_CTRL_KEY_AGREE_DECRYPT_PARA', SizeOf(_CMSG_CTRL_KEY_AGREE_DECRYPT_PARA)]));
  Writeln(Format('%-50s %8d', ['_CMSG_CTRL_MAIL_LIST_DECRYPT_PARA', SizeOf(_CMSG_CTRL_MAIL_LIST_DECRYPT_PARA)]));
  Writeln(Format('%-50s %8d', ['_CMSG_CTRL_ADD_SIGNER_UNAUTH_ATTR_PARA', SizeOf(_CMSG_CTRL_ADD_SIGNER_UNAUTH_ATTR_PARA )]));
  Writeln(Format('%-50s %8d', ['_CMSG_CTRL_DEL_SIGNER_UNAUTH_ATTR_PARA', SizeOf(_CMSG_CTRL_DEL_SIGNER_UNAUTH_ATTR_PARA )]));
  Writeln(Format('%-50s %8d', ['_CMSG_CONTENT_ENCRYPT_INFO', SizeOf(_CMSG_CONTENT_ENCRYPT_INFO )]));
  Writeln(Format('%-50s %8d', ['_CMSG_KEY_TRANS_ENCRYPT_INFO', SizeOf(_CMSG_KEY_TRANS_ENCRYPT_INFO )]));
  Writeln(Format('%-50s %8d', ['_CMSG_KEY_AGREE_KEY_ENCRYPT_INFO', SizeOf(_CMSG_KEY_AGREE_KEY_ENCRYPT_INFO )]));
  Writeln(Format('%-50s %8d', ['_CMSG_KEY_AGREE_ENCRYPT_INFO', SizeOf(_CMSG_KEY_AGREE_ENCRYPT_INFO)]));
  Writeln(Format('%-50s %8d', ['_CMSG_MAIL_LIST_ENCRYPT_INFO', SizeOf(_CMSG_MAIL_LIST_ENCRYPT_INFO )]));
  Writeln(Format('%-50s %8d', ['_CMSG_CNG_CONTENT_DECRYPT_INFO', SizeOf(_CMSG_CNG_CONTENT_DECRYPT_INFO)]));
  Writeln(Format('%-50s %8d', ['_CERT_CONTEXT', SizeOf(_CERT_CONTEXT)]));
  Writeln(Format('%-50s %8d', ['_CRL_CONTEXT', SizeOf(_CRL_CONTEXT)]));
  Writeln(Format('%-50s %8d', ['_CTL_CONTEXT', SizeOf(_CTL_CONTEXT)]));
  Writeln(Format('%-50s %8d', ['_CRYPT_KEY_PROV_PARAM', SizeOf(_CRYPT_KEY_PROV_PARAM)]));
  Writeln(Format('%-50s %8d', ['_CRYPT_KEY_PROV_INFO', SizeOf(_CRYPT_KEY_PROV_INFO )]));
  Writeln(Format('%-50s %8d', ['_CERT_KEY_CONTEXT', SizeOf(_CERT_KEY_CONTEXT)]));
  Writeln(Format('%-50s %8d', ['_ROOT_INFO_LUID', SizeOf(_ROOT_INFO_LUID)]));
  Writeln(Format('%-50s %8d', ['_CRYPT_SMART_CARD_ROOT_INFO', SizeOf(_CRYPT_SMART_CARD_ROOT_INFO )]));
  Writeln(Format('%-50s %8d', ['_CERT_SYSTEM_STORE_RELOCATE_PARA', SizeOf(_CERT_SYSTEM_STORE_RELOCATE_PARA )]));
  Writeln(Format('%-50s %8d', ['_CERT_REGISTRY_STORE_CLIENT_GPT_PARA', SizeOf(_CERT_REGISTRY_STORE_CLIENT_GPT_PARA )]));
  Writeln(Format('%-50s %8d', ['_CERT_REGISTRY_STORE_ROAMING_PARA', SizeOf(_CERT_REGISTRY_STORE_ROAMING_PARA )]));
  Writeln(Format('%-50s %8d', ['_CERT_LDAP_STORE_OPENED_PARA', SizeOf(_CERT_LDAP_STORE_OPENED_PARA )]));
  Writeln(Format('%-50s %8d', ['_CERT_STORE_PROV_INFO', SizeOf(_CERT_STORE_PROV_INFO)]));
  Writeln(Format('%-50s %8d', ['_CERT_STORE_PROV_FIND_INFO', SizeOf(_CERT_STORE_PROV_FIND_INFO )]));
  Writeln(Format('%-50s %8d', ['_CRL_FIND_ISSUED_FOR_PARA', SizeOf(_CRL_FIND_ISSUED_FOR_PARA )]));
  Writeln(Format('%-50s %8d', ['_CTL_ANY_SUBJECT_INFO', SizeOf(_CTL_ANY_SUBJECT_INFO )]));
  Writeln(Format('%-50s %8d', ['_CTL_FIND_USAGE_PARA', SizeOf(_CTL_FIND_USAGE_PARA )]));
  Writeln(Format('%-50s %8d', ['_CTL_FIND_SUBJECT_PARA', SizeOf(_CTL_FIND_SUBJECT_PARA )]));
  Writeln(Format('%-50s %8d', ['_CERT_CREATE_CONTEXT_PARA', SizeOf(_CERT_CREATE_CONTEXT_PARA)]));
  Writeln(Format('%-50s %8d', ['_CERT_SYSTEM_STORE_INFO', SizeOf(_CERT_SYSTEM_STORE_INFO)]));
  Writeln(Format('%-50s %8d', ['_CERT_PHYSICAL_STORE_INFO', SizeOf(_CERT_PHYSICAL_STORE_INFO)]));
  Writeln(Format('%-50s %8d', ['_CTL_VERIFY_USAGE_PARA', SizeOf(_CTL_VERIFY_USAGE_PARA)]));
  Writeln(Format('%-50s %8d', ['_CTL_VERIFY_USAGE_STATUS', SizeOf(_CTL_VERIFY_USAGE_STATUS)]));
  Writeln(Format('%-50s %8d', ['_CERT_REVOCATION_CRL_INFO', SizeOf(_CERT_REVOCATION_CRL_INFO)]));
  Writeln(Format('%-50s %8d', ['_CERT_REVOCATION_PARA', SizeOf(_CERT_REVOCATION_PARA )]));
  Writeln(Format('%-50s %8d', ['_CERT_REVOCATION_STATUS', SizeOf(_CERT_REVOCATION_STATUS)]));
  Writeln(Format('%-50s %8d', ['_CRYPT_DEFAULT_CONTEXT_MULTI_OID_PARA', SizeOf(_CRYPT_DEFAULT_CONTEXT_MULTI_OID_PARA )]));
  Writeln(Format('%-50s %8d', ['_CRYPT_SIGN_MESSAGE_PARA', SizeOf(_CRYPT_SIGN_MESSAGE_PARA )]));
  Writeln(Format('%-50s %8d', ['_CRYPT_VERIFY_MESSAGE_PARA', SizeOf(_CRYPT_VERIFY_MESSAGE_PARA)]));
  Writeln(Format('%-50s %8d', ['_CRYPT_ENCRYPT_MESSAGE_PARA', SizeOf(_CRYPT_ENCRYPT_MESSAGE_PARA)]));
  Writeln(Format('%-50s %8d', ['_CRYPT_DECRYPT_MESSAGE_PARA', SizeOf(_CRYPT_DECRYPT_MESSAGE_PARA )]));
  Writeln(Format('%-50s %8d', ['_CRYPT_HASH_MESSAGE_PARA', SizeOf(_CRYPT_HASH_MESSAGE_PARA )]));
  Writeln(Format('%-50s %8d', ['_CRYPT_KEY_SIGN_MESSAGE_PARA', SizeOf(_CRYPT_KEY_SIGN_MESSAGE_PARA )]));
  Writeln(Format('%-50s %8d', ['_CRYPT_KEY_VERIFY_MESSAGE_PARA', SizeOf(_CRYPT_KEY_VERIFY_MESSAGE_PARA )]));
  Writeln(Format('%-50s %8d', ['_CERT_CHAIN', SizeOf(_CERT_CHAIN )]));
  Writeln(Format('%-50s %8d', ['_CRYPT_BLOB_ARRAY', SizeOf(_CRYPT_BLOB_ARRAY)]));
  Writeln(Format('%-50s %8d', ['_CRYPT_CREDENTIALS', SizeOf(_CRYPT_CREDENTIALS )]));
  Writeln(Format('%-50s %8d', ['_CRYPT_PASSWORD_CREDENTIALSA', SizeOf(_CRYPT_PASSWORD_CREDENTIALSA )]));
  Writeln(Format('%-50s %8d', ['_CRYPT_PASSWORD_CREDENTIALSW', SizeOf(_CRYPT_PASSWORD_CREDENTIALSW)]));
  Writeln(Format('%-50s %8d', ['_CRYPTNET_URL_CACHE_PRE_FETCH_INFO', SizeOf(_CRYPTNET_URL_CACHE_PRE_FETCH_INFO)]));
  Writeln(Format('%-50s %8d', ['_CRYPTNET_URL_CACHE_FLUSH_INFO', SizeOf(_CRYPTNET_URL_CACHE_FLUSH_INFO )]));
  Writeln(Format('%-50s %8d', ['_CRYPTNET_URL_CACHE_RESPONSE_INFO', SizeOf(_CRYPTNET_URL_CACHE_RESPONSE_INFO)]));
  Writeln(Format('%-50s %8d', ['_CRYPT_RETRIEVE_AUX_INFO', SizeOf(_CRYPT_RETRIEVE_AUX_INFO )]));
  Writeln(Format('%-50s %8d', ['_CRYPT_ASYNC_RETRIEVAL_COMPLETION', SizeOf(_CRYPT_ASYNC_RETRIEVAL_COMPLETION )]));
  Writeln(Format('%-50s %8d', ['_CRYPT_URL_ARRAY', SizeOf(_CRYPT_URL_ARRAY )]));
  Writeln(Format('%-50s %8d', ['_CRYPT_URL_INFO', SizeOf(_CRYPT_URL_INFO)]));
  Writeln(Format('%-50s %8d', ['_CERT_CRL_CONTEXT_PAIR', SizeOf(_CERT_CRL_CONTEXT_PAIR)]));
  Writeln(Format('%-50s %8d', ['_CRYPT_GET_TIME_VALID_OBJECT_EXTRA_INFO', SizeOf(_CRYPT_GET_TIME_VALID_OBJECT_EXTRA_INFO)]));
  Writeln(Format('%-50s %8d', ['_CRYPTPROTECT_PROMPTSTRUCT', SizeOf(_CRYPTPROTECT_PROMPTSTRUCT )]));
  Writeln(Format('%-50s %8d', ['_CERT_CHAIN_ENGINE_CONFIG', SizeOf(_CERT_CHAIN_ENGINE_CONFIG )]));
  Writeln(Format('%-50s %8d', ['_CERT_TRUST_STATUS', SizeOf(_CERT_TRUST_STATUS )]));
  Writeln(Format('%-50s %8d', ['_CERT_REVOCATION_INFO', SizeOf(_CERT_REVOCATION_INFO )]));
  Writeln(Format('%-50s %8d', ['_CERT_TRUST_LIST_INFO', SizeOf(_CERT_TRUST_LIST_INFO)]));
  Writeln(Format('%-50s %8d', ['_CERT_CHAIN_ELEMENT', SizeOf(_CERT_CHAIN_ELEMENT)]));
  Writeln(Format('%-50s %8d', ['_CERT_SIMPLE_CHAIN', SizeOf(_CERT_SIMPLE_CHAIN)]));
  Writeln(Format('%-50s %8d', ['_CERT_CHAIN_CONTEXT', SizeOf(_CERT_CHAIN_CONTEXT)]));
  Writeln(Format('%-50s %8d', ['_CERT_USAGE_MATCH', SizeOf(_CERT_USAGE_MATCH )]));
  Writeln(Format('%-50s %8d', ['_CTL_USAGE_MATCH', SizeOf(_CTL_USAGE_MATCH )]));
  Writeln(Format('%-50s %8d', ['_CERT_CHAIN_PARA', SizeOf(_CERT_CHAIN_PARA )]));
  Writeln(Format('%-50s %8d', ['_CRL_REVOCATION_INFO', SizeOf(_CRL_REVOCATION_INFO )]));
  Writeln(Format('%-50s %8d', ['_CERT_CHAIN_FIND_BY_ISSUER_PARA', SizeOf(_CERT_CHAIN_FIND_BY_ISSUER_PARA )]));
  Writeln(Format('%-50s %8d', ['_CERT_CHAIN_POLICY_PARA', SizeOf(_CERT_CHAIN_POLICY_PARA )]));
  Writeln(Format('%-50s %8d', ['_CERT_CHAIN_POLICY_STATUS', SizeOf(_CERT_CHAIN_POLICY_STATUS )]));
  Writeln(Format('%-50s %8d', ['_AUTHENTICODE_EXTRA_CERT_CHAIN_POLICY_PARA', SizeOf(_AUTHENTICODE_EXTRA_CERT_CHAIN_POLICY_PARA )]));
  Writeln(Format('%-50s %8d', ['_AUTHENTICODE_EXTRA_CERT_CHAIN_POLICY_STATUS', SizeOf(_AUTHENTICODE_EXTRA_CERT_CHAIN_POLICY_STATUS )]));
  Writeln(Format('%-50s %8d', ['_AUTHENTICODE_TS_EXTRA_CERT_CHAIN_POLICY_PARA', SizeOf(_AUTHENTICODE_TS_EXTRA_CERT_CHAIN_POLICY_PARA )]));
  Writeln(Format('%-50s %8d', ['_HTTPSPolicyCallbackData', SizeOf(_HTTPSPolicyCallbackData)]));
  Writeln(Format('%-50s %8d', ['_CRYPT_PKCS12_PBE_PARAMS', SizeOf(_CRYPT_PKCS12_PBE_PARAMS)]));
  Writeln(Format('%-50s %8d', ['_CERT_SERVER_OCSP_RESPONSE_CONTEXT', SizeOf(_CERT_SERVER_OCSP_RESPONSE_CONTEXT)]));

  Writeln;
  Writeln('bcrypt');
  Writeln('------');
  Writeln;

  Writeln(Format('%-50s %8d', ['__BCRYPT_KEY_LENGTHS_STRUCT', SizeOf(__BCRYPT_KEY_LENGTHS_STRUCT)]));
  Writeln(Format('%-50s %8d', ['_BCRYPT_PKCS1_PADDING_INFO', SizeOf(_BCRYPT_PKCS1_PADDING_INFO)]));
  Writeln(Format('%-50s %8d', ['_BCRYPT_PSS_PADDING_INFO', SizeOf(_BCRYPT_PSS_PADDING_INFO)]));
  Writeln(Format('%-50s %8d', ['_BCRYPT_OAEP_PADDING_INFO', SizeOf(_BCRYPT_OAEP_PADDING_INFO)]));
  Writeln(Format('%-50s %8d', ['_BCryptBuffer', SizeOf(_BCryptBuffer)]));
  Writeln(Format('%-50s %8d', ['_BCryptBufferDesc', SizeOf(_BCryptBufferDesc)]));
  Writeln(Format('%-50s %8d', ['_BCRYPT_KEY_BLOB', SizeOf(_BCRYPT_KEY_BLOB)]));
  Writeln(Format('%-50s %8d', ['_BCRYPT_RSAKEY_BLOB', SizeOf(_BCRYPT_RSAKEY_BLOB)]));
  Writeln(Format('%-50s %8d', ['_BCRYPT_ECCKEY_BLOB', SizeOf(_BCRYPT_ECCKEY_BLOB)]));
  Writeln(Format('%-50s %8d', ['_BCRYPT_DH_KEY_BLOB', SizeOf(_BCRYPT_DH_KEY_BLOB)]));
  Writeln(Format('%-50s %8d', ['_BCRYPT_DH_PARAMETER_HEADER', SizeOf(_BCRYPT_DH_PARAMETER_HEADER)]));
  Writeln(Format('%-50s %8d', ['_BCRYPT_DSA_KEY_BLOB', SizeOf(_BCRYPT_DSA_KEY_BLOB)]));
  Writeln(Format('%-50s %8d', ['_BCRYPT_KEY_DATA_BLOB_HEADER', SizeOf(_BCRYPT_KEY_DATA_BLOB_HEADER)]));
  Writeln(Format('%-50s %8d', ['_BCRYPT_DSA_PARAMETER_HEADER', SizeOf(_BCRYPT_DSA_PARAMETER_HEADER)]));
  Writeln(Format('%-50s %8d', ['_BCRYPT_ALGORITHM_IDENTIFIER', SizeOf(_BCRYPT_ALGORITHM_IDENTIFIER)]));
  Writeln(Format('%-50s %8d', ['_BCRYPT_PROVIDER_NAME', SizeOf(_BCRYPT_PROVIDER_NAME)]));
  Writeln(Format('%-50s %8d', ['_BCRYPT_INTERFACE_VERSION', SizeOf(_BCRYPT_INTERFACE_VERSION)]));
  Writeln(Format('%-50s %8d', ['_CRYPT_INTERFACE_REG', SizeOf(_CRYPT_INTERFACE_REG)]));
  Writeln(Format('%-50s %8d', ['_CRYPT_IMAGE_REG', SizeOf(_CRYPT_IMAGE_REG)]));
  Writeln(Format('%-50s %8d', ['_CRYPT_PROVIDER_REG', SizeOf(_CRYPT_PROVIDER_REG)]));
  Writeln(Format('%-50s %8d', ['_CRYPT_PROVIDERS', SizeOf(_CRYPT_PROVIDERS)]));
  Writeln(Format('%-50s %8d', ['_CRYPT_CONTEXT_CONFIG', SizeOf(_CRYPT_CONTEXT_CONFIG)]));
  Writeln(Format('%-50s %8d', ['_CRYPT_CONTEXT_FUNCTION_CONFIG', SizeOf(_CRYPT_CONTEXT_FUNCTION_CONFIG)]));
  Writeln(Format('%-50s %8d', ['_CRYPT_CONTEXTS', SizeOf(_CRYPT_CONTEXTS)]));
  Writeln(Format('%-50s %8d', ['_CRYPT_CONTEXT_FUNCTIONS', SizeOf(_CRYPT_CONTEXT_FUNCTIONS)]));
  Writeln(Format('%-50s %8d', ['_CRYPT_CONTEXT_FUNCTION_PROVIDERS', SizeOf(_CRYPT_CONTEXT_FUNCTION_PROVIDERS)]));
  Writeln(Format('%-50s %8d', ['_CRYPT_PROPERTY_REF', SizeOf(_CRYPT_PROPERTY_REF)]));
  Writeln(Format('%-50s %8d', ['_CRYPT_IMAGE_REF', SizeOf(_CRYPT_IMAGE_REF)]));
  Writeln(Format('%-50s %8d', ['_CRYPT_PROVIDER_REF', SizeOf(_CRYPT_PROVIDER_REF)]));
  Writeln(Format('%-50s %8d', ['_CRYPT_PROVIDER_REFS', SizeOf(_CRYPT_PROVIDER_REFS)]));

  Writeln;
  Writeln('ncrypt');
  Writeln('------');
  Writeln;

  Writeln(Format('%-50s %8d', ['_NCryptAlgorithmName', SizeOf(_NCryptAlgorithmName)]));
  Writeln(Format('%-50s %8d', ['NCryptKeyName', SizeOf(NCryptKeyName)]));
  Writeln(Format('%-50s %8d', ['NCryptProviderName', SizeOf(NCryptProviderName)]));
  Writeln(Format('%-50s %8d', ['__NCRYPT_UI_POLICY_BLOB', SizeOf(__NCRYPT_UI_POLICY_BLOB)]));
  Writeln(Format('%-50s %8d', ['__NCRYPT_UI_POLICY', SizeOf(__NCRYPT_UI_POLICY)]));
  Writeln(Format('%-50s %8d', ['__NCRYPT_SUPPORTED_LENGTHS', SizeOf(__NCRYPT_SUPPORTED_LENGTHS)]));

end;

end.
